;r3toolbx.sc, a collection of obscure, yet useful tools from r3 Software

;suggestions and comments are greatly encouraged!!!  

;7 procs: 
;   get.color.attribute.s : takes the guess-work out of colors
;     view.date.formats.u : can't remember the date format?
;                undent.u : for those times you don't have PAL-Edit...
;   get.sub.directories.u : gives you a listing of sub directories
;         rda.navigator.u : makes it a little easier to get around an app
;         catalog.forms.u : a quick, little form cataloger
;       catalog.reports.u : a quick, little report cataloger

;  NOTE:  if you want to use these on a regular basis, you may want to
;         activate the SETKEY commands, as well as split the procs out into
;         their own scripts

;Copyright (c) 1995 by Skip Rowland/r3 Software Publishing & Consulting, Inc.
;released to the public domain; however, these utilities cannot be included in
; in any commercial software without prior written permission of the author.
;         

;please address questions, comments, suggestions to: 
; Skip Rowland/r3 Software  Publishing & Consulting, Inc.
; (804) 739 - 7474
; CID 75260,2107

;---------------------------------------------
PROC get.color.attribute.s ()
;this proc paints a window on the canvas and allows you to change the color
; attributes with the up/down/left/right keys.  if you are in an editor
; window, pressing the enter key will insert the current color at the 
; current cursor position.
  PRIVATE
    wa,
    h,
    color.s,
    keyname.a,
    event.y,
    change.s
  
  SHOWPULLDOWN ENDMENU
  SPEEDBAR "~Esc~ Quit":"Esc"
  
  ECHO OFF 
;  SETKEY -103 PLAY "colors"  ;ctrl-f10
   
  color.s = 1
  
  DYNARRAY wa []
  wa ["FLOATING"] = TRUE
  wa ["HASFRAME"] = FALSE
  
  WINDOW CREATE @2,2 HEIGHT 8 WIDTH 40 ATTRIBUTES wa TO h
  
  @1,2 ?? "Up/Down    : change BackGround"
  @2,2 ?? "Left/Right : change ForeGround"
  @4,2 ?? "Enter      : EDITOR INSERT color.s"
  @5,2 ?? "               color.s = " + STRVAL (color.s) + "   "
  @6,2 ?? "Esc        : QUIT"
  
  ECHO NORMAL
  WHILE TRUE
    @5,2 ?? "               color.s = " + STRVAL (color.s) + "   "
    PAINTCANVAS ATTRIBUTE color.s 0,0,8,40 
    GETEVENT KEY "ESC","UP","DOWN","LEFT","RIGHT","ENTER" TO event.y
    keyname.a = LOWER (KEYNAME (event.y ["KEYCODE"]))
    SWITCH
      CASE keyname.a = "up"     : change.s = 16
      CASE keyname.a = "down"   : change.s = -16
      CASE keyname.a = "left"   : change.s = -1
      CASE keyname.a = "right"  : change.s = 1
      CASE keyname.a = "enter"  : 
        WINCLOSE
        IF SEARCH (SYSMODE (), "Script File Editor") = 0 THEN
          MESSAGE "Color: ", color.s, ". Press any key."
          g = GETCHAR ()
        ELSE
          EDITOR INSERT color.s
        ENDIF
        QUITLOOP 
      CASE keyname.a = "esc"    : 
        WINCLOSE
        QUITLOOP
    ENDSWITCH
    color.s= color.s + change.s 
    color.s= IIF (color.s < 0, 0, color.s)
    color.s= IIF (color.s > 255, 255, color.s)
  ENDWHILE  
  
  CLEARSPEEDBAR
  
ENDPROC

;get.color.attribute.s ()

;---------------------------------------------
PROC view.date.formats.u ()
;this proc paints a canvas window that shows the various date format codes 
; with examples

  PRIVATE
    d,
    wa,
    h,
    g,
    a

  SHOWPULLDOWN ENDMENU
  SPEEDBAR "~AnyKey~":"Esc"
  
  d = TODAY ()
  DYNARRAY wa []
    wa ["hasframe"] = FALSE
    wa ["floating"] = TRUE
    
  WINDOW CREATE @2,2 HEIGHT 16 WIDTH 28 ATTRIBUTES wa TO h
  
  ? "  Date Formats:"
  ?
  FOR a FROM 1 TO 12
    ? "  ", FORMAT ("w6", "D"+ STRVAL (a)), FORMAT ("w18,d" + STRVAL (a) + "\"", d)
  ENDFOR
  
  PAINTCANVAS ATTRIBUTE 31 0,0,17,29
  PAINTCANVAS ATTRIBUTE 30 1,0,1,29
  ECHO NORMAL
  g = GETCHAR ()
  
  WINDOW CLOSE
  CLEARSPEEDBAR
  
;  SETKEY -102 PLAY "datefrmt"  ;ctrl-f9
  
ENDPROC

;view.date.formats.u ()

;---------------------------------------------
PROC undent.u ()
;for those times you don't have access to PAL-Edit and you need to move a
; column of text, this can be very handy.
  PRIVATE 
    current.end.block.y,  ;editor info dynarray for the current end of block
    block.y,              ;editor info dynarray for selected block           
    startpos.n,           ;the position of the first char in the home position of the first line of selected text
    endpos.n,             ;the position of the first char in the end position of the last line of selected text
    start.block.y,        ;editor info dynarray for start of block
    end.block.y,          ;editor info dynarray for end of block
    maxchar.y,            ;dynarray of number of spaces at start of each line
    ct.s,                 ;counter for looping by integer
    a,                    ;counter for looping by integer
    e,                    ;counter for looping through dynarray
    check.a,              ;char checker
    maxleft.s,            ;maximum keystrokes to the left before a character hits the wall
    strokes.s,            ;stroke counter:  -1 right, +1 left
    space.a               ;string of spaces at start of each line
  
  ;  SETKEY 21 PLAY "undent"
  
  EDITOR INFO COMPLETE TO block.y
  IF NOT RETVAL THEN
    KEYPRESS 21
    RETURN ""
  ENDIF
  
  IF block.y ["SELSTART"] = 0 AND block.y ["SELEND"] = 0 THEN
    RETURN "No text selected"
  ENDIF

  SHOWPULLDOWN ENDMENU
  SPEEDBAR "~R~ight Indent":"RIGHT","~L~eft Undent":"LEFT", "~Esc~ Leave Undent":"Esc"
  PROMPT SPACES (80)
  
  IF block.y ["SELSTART"] >= block.y ["SELEND"] THEN  
    startpos.n = block.y ["SELEND"]
    endpos.n = block.y ["SELSTART"]
  ELSE    
    startpos.n = block.y ["SELSTART"]
    endpos.n = block.y ["SELEND"]
  ENDIF
  
  EDITOR GOTO POSITION startpos.n
  HOME
  EDITOR INFO COMPLETE TO start.block.y
  startpos.n = start.block.y ["CHARPOS"]
  EDITOR GOTO POSITION endpos.n
  EDITOR INFO COMPLETE TO end.block.y
  RIGHT
  EDITOR INFO COMPLETE TO current.end.block.y
  current.end.block.y ["CHARPOS"] = current.end.block.y ["CHARPOS"] - 1
  
  DYNARRAY maxchar.y []
  EDITOR GOTO POSITION startpos.n

  FOR a FROM start.block.y ["CURLINE"] TO end.block.y ["CURLINE"]
    HOME
    CTRLRIGHT
    SHIFTPRESS "HOME"
    EDITOR EXTRACT TO space.a
    maxchar.y [a] = LEN (space.a) + 1
    DOWN
  ENDFOR
  
  maxleft.s = 255
  FOREACH e IN maxchar.y
    maxleft.s = IIF (maxchar.y [e] < maxleft.s, maxchar.y [e], maxleft.s)
  ENDFOREACH  
  
  EDITOR SELECT startpos.n IIF (ISASSIGNED (current.end.block.y), current.end.block.y ["CHARPOS"], endpos.n)
  
  strokes.s = 0
  WHILE TRUE
    ECHO NORMAL ECHO OFF
    GETEVENT KEY "ALL" TO messagend.block.y

    SWITCH
      CASE messagend.block.y ["KEYCODE"] = -77 :  ;RIGHT
        strokes.s = strokes.s - 1
        EDITOR GOTO POSITION startpos.n
        FOR ct.s FROM 1 TO end.block.y ["CURLINE"] - start.block.y ["CURLINE"] + 1
          HOME
          EDITOR INSERT " "
          DOWN
        ENDFOR

        current.end.block.y ["CHARPOS"] = current.end.block.y ["CHARPOS"] + ct.s - 1
        EDITOR SELECT startpos.n current.end.block.y ["CHARPOS"]

      CASE messagend.block.y ["KEYCODE"] = -75 : ;LEFT
      
        strokes.s = strokes.s + 1
        IF strokes.s >= maxleft.s THEN
          BEEP
          strokes.s = strokes.s - 1
          LOOP
        ENDIF
        
        EDITOR GOTO POSITION startpos.n
        HOME
        FOR ct.s FROM 1 TO end.block.y ["CURLINE"] - start.block.y ["CURLINE"] + 1
          RELEASE VARS check.a
          SHIFTPRESS "END"
          EDITOR EXTRACT TO check.a
          IF LEN (check.a) > 0 THEN
            DEL
          ENDIF
          DOWN
        ENDFOR

        current.end.block.y ["CHARPOS"] = current.end.block.y ["CHARPOS"] - ct.s + 1
        EDITOR SELECT startpos.n current.end.block.y ["CHARPOS"]

      OTHERWISE: 
        EDITOR SELECT startpos.n IIF (ISASSIGNED (current.end.block.y), current.end.block.y ["CHARPOS"], endpos.n)
        QUITLOOP  
    ENDSWITCH  
  ENDWHILE  

  CLEARPULLDOWN
  CLEARSPEEDBAR

  RETURN ""
  
ENDPROC

;RETURN undent.u ()

;---------------------------------------------
PROC get.sub.directories.u ()
;this proc generates a list of sub directories beneath the current dir
  PRIVATE
    subs.y,
    sub.ctr,
    dirname.a,
    a

  ECHO OFF
  RUN NOREFRESH "DIR *. /s >subs.txt"
  EDITOR OPEN "subs.txt"

  DYNARRAY subs.y []
  sub.ctr = 0
  
  WHILE TRUE
    EDITOR FIND "Directory of "
    IF NOT RETVAL THEN
      MENU {Cancel} {Yes}
      QUITLOOP
    ENDIF
    
    DEL
    SHIFTPRESS "END"
    EDITOR EXTRACT TO dirname.a
    
    sub.ctr = sub.ctr + 1
    subs.y [sub.ctr] = dirname.a
    DEL
  ENDWHILE
  
  EDITOR NEW "subs.txt" MENU {Cancel} {Yes}
  EDITOR NEW "savevars.sc" MENU {Cancel} {Yes}
  
  FOR a FROM 1 TO DYNARRAYSIZE (subs.y)
    PRINT FILE "savevars.sc" subs.y [a], "\n"
  ENDFOR
  
  EDITOR OPEN "savevars.sc"
  WINDOW HANDLE EDITOR TO e.h
  IF NOT ISASSIGNED (demo.l) THEN
    RETURN
  ENDIF
  
  SHOWPULLDOWN ENDMENU
  SPEEDBAR "~Esc~ Quit":"Esc"
  
  ECHO NORMAL
  WHILE TRUE
    GETEVENT
      KEY "ALL"
      TO message.y
    
    SWITCH
      CASE message.y ["KEYCODE"] = -60 OR
           message.y ["KEYCODE"] = 27 : 
             DO_IT!
             QUITLOOP
      OTHERWISE :
        IF NOT ISWINDOW (e.h) THEN
          QUITLOOP
        ENDIF
        KEYPRESS message.y ["KEYCODE"]
    ENDSWITCH
  ENDWHILE  
  
  CLEARSPEEDBAR
  
ENDPROC

;get.sub.directories.u ()  

;---------------------------------------------
PROC rda.navigator.u ()
;you might want to set you own setkey; this is set to alt-v.
;you'll also need to edit the directories before you can use it.  it simply
;  gives you a pulldown of directories to jump to with a few keystrokes...
;  beats the hell out of Tools|More|Directory...

  SETKEY -47 PLAY "zdirgo"  ;to use multiple copies (if you have more than
                            ; one project going at a time), simply add the
                            ; full script name to the SETKEY line.   

  choice.a = IIF (NOT ISASSIGNED (choice.a), "c:\\appsdir\\SOURCE\\", choice.a)
  IF choice.a = "Esc" THEN
    "c:\\appdir\\SOURCE\\"
  ENDIF
  
  SHOWPULLDOWN
    "AppName" : "" : ""  ;this is the app name.  below are its dirs
      SUBMENU
        "Source"    : "" : "c:\\appdir\\SOURCE\\",
        "Data"      : "" : "c:\\appdir\\DATA\\",
        "WorkStat"  : "" : "c:\\appdir\\WORKSTAT\\",
        "Errors"    : "" : "c:\\appdir\\data\\ERR-LOGS\\",
        SEPARATOR,
        "r3~U~tils" : "" : "c:\\TOOLBOX\\R3UTILS\\"
      ENDSUBMENU
  ENDMENU
  
  GETMENUSELECTION DEFAULT choice.a TO choice.a
  IF DIREXISTS (choice.a) = 1 THEN
    SETDIR choice.a
  ELSE
    MESSAGE "rda.navigator is improperly configured!"
  ENDIF

ENDPROC

;rda.navigator.u ()

;---------------------------------------------
PROC catalog.forms.u ()
;this proc builds a list of forms in the current directory, then analyzes
; them, putting the results in a table
  PRIVATE
    g,
    m,
    table.a,
    form.a,
    forms.y,
    forms.r

  MESSAGE "Pulling Form Inventory..."
  ECHO OFF
  MENU "TIIF" {*.f??}
  IF ISEMPTY ("List") THEN
    MESSAGE "No forms found in this directory...Press any key"
    g = GETCHAR ()
    RETURN
  ENDIF
  
  MENU "MR" {List}
  CTRLEND
  CTRLBACKSPACE
  
  "A13 "
  DOWN DEL UP ENTER
  "Table"       TAB "A8"  ENTER
  "Form"        TAB "A3"  ENTER
  "Description" TAB "A40" ENTER
  "Linked"      TAB "A1"  ENTER
  "Date"        TAB "D" 
  DO_IT!
  {Trimming}

  DELETE "Struct"
  RENAME "list" "aforms"
  
  COEDITKEY
  SCAN
    m = MATCH ([Name], "..\".\"..", table.a, form.a)
    MESSAGE [Name]
    [Table] = table.a
    [Form] = IIF (form.a = "f", "F", SUBSTR (form.a, 2, LEN (form.a)-1))
    TABLEINFO table.a FORMS TO forms.y
    [Description] = IIF (ISASSIGNED (forms.y [[Form]]),forms.y [[Form]],"")
    FORMTABLES [Table] [Form] forms.r
    [Linked] = IIF (RETVAL,"Y","")
  ENDSCAN
  DO_IT!
  
  MENU "MR" {aforms}
  DEL
  DO_IT!
  {Delete}
  DELETE "Struct"
  
  IF ISASSIGNED (demo.l) THEN
    ECHO NORMAL
    SHOWPULLDOWN ENDMENU
    SPEEDBAR "~F2~ Done":"F2"
    
    WAIT TABLE EXIT TRIGGER "DONE" ENDWAIT

    ECHO OFF
    CLEARIMAGE
    CLEARSPEEDBAR
    ECHO NORMAL ECHO OFF
  ENDIF

ENDPROC

;---------------------------------------------
PROC catalog.reports.u ()
;this proc builds a list of reports in the current directory, then analyzes
; them, putting the results in a table
  PRIVATE
    g,
    m,
    table.a,
    report.a,
    reports.y,
    reports.r

  MESSAGE "Pulling Report Inventory..."
  ECHO OFF
  MENU "TIIF" {*.r??}
  IF ISEMPTY ("List") THEN
    MESSAGE "No reports found in this directory...Press any key"
    g = GETCHAR ()
    RETURN
  ENDIF
  MENU "MR" {List}
  CTRLEND
  CTRLBACKSPACE
  
  "A13 "
  DOWN DEL UP ENTER
  "Table"       TAB "A8"  ENTER
  "Report"      TAB "A3"  ENTER
  "Description" TAB "A40" ENTER
  "Linked"      TAB "A1"  ENTER
  "Date"        TAB "D" 
  DO_IT!
  {Trimming}

  DELETE "Struct"
  RENAME "list" "areports"
  
  COEDITKEY
  SCAN
    m = MATCH ([Name], "..\".\"..", table.a, report.a)
    MESSAGE [Name]
    [Table] = table.a
    [Report] = IIF (report.a = "r", "R", SUBSTR (report.a, 2, LEN (report.a)-1))
    TABLEINFO table.a REPORTS TO reports.y
    [Description] = reports.y [[Report]]
    REPORTTABLES [Table] [Report] reports.r
    [Linked] = IIF (RETVAL,"Y","")
  ENDSCAN
  DO_IT!
  
  MENU "MR" {areports}
  DEL
  DO_IT!
  {Delete}
  DELETE "Struct"

  IF ISASSIGNED (demo.l) THEN
    ECHO NORMAL
    SHOWPULLDOWN ENDMENU
    SPEEDBAR "~F2~ Done":"F2"
    
    WAIT TABLE EXIT TRIGGER "DONE" ENDWAIT

    ECHO OFF
    CLEARIMAGE
    CLEARSPEEDBAR
    ECHO NORMAL ECHO OFF
  ENDIF
  
ENDPROC


PROC sample.menu.u ()

  SHOWPULLDOWN
    "r3Tools" : " Tools You Can Use" : ""
      SUBMENU
        "Get Colors"   : " Takes the guess-work out of colors"         : "get.color.attribute.s",
        "Date Formats" : " Can't remember the date format?"            : "view.date.formats.u",
        "Undent"       : " For those times you don't have PAL-Edit..." : "undent.u",
        "Sub-Dirs"     : " Gives you a listing of sub directories"     : "get.sub.directories.u",
        "RDA Nav"      : " Makes it a little easier to get around an app" : "rda.navigator.u",
        "Catalogs"     : " Form & Report Catalogers" : ""
          SUBMENU
            "Forms"    : " A quick, little form cataloger"             : "catalog.forms.u",
            "Reports"  : " A quick, little report cataloger"           : "catalog.reports.u"
          ENDSUBMENU
      ENDSUBMENU,
    "Leave" : " Leave the demo" : "leave"
  ENDMENU        
  
ENDPROC


PROC run.demo.u ()
  PRIVATE
    menu.choice.a,
    demo.l
  
  demo.l = TRUE
  
  menu.choice.a = ""  
  WHILE TRUE
    sample.menu.u ()
    GETMENUSELECTION DEFAULT menu.choice.a TO menu.choice.a
    SWITCH
      CASE ISPROC (menu.choice.a) : EXECPROC menu.choice.a
      CASE menu.choice.a = "leave" : QUITLOOP
    ENDSWITCH
  ENDWHILE

ENDPROC

run.demo.u ()