;r3zip2tb.sc, a zip file tool from r3 Software 

;a useful tool for seeing what is in a zip file and comparing it to other
; zip files.  gives you a more information than doing Tools|Info|Inventory 
; and renaming the 'List' table in a couple dirs...

;HELP ME:  suggestions for ENHANCEMENTS are greatly encouraged!!!  please
; let me know what other functionality you think would be useful!
  
;5 procs: zip.to.table.u:   puts zip file info into a table
;         promptdialog.a:   a dialog box that returns an alpha
;         escape.menu.u :   clears menu, prompt, sets speedbar to Esc
;         win.message.h :   displays a progress message, returns a win handle
;         winclose.u    :   closes a specified window
      
;it is ready to go, just play it and it will do all the work.

;Copyright (c) 1995 by Skip Rowland/r3 Software Publishing & Consulting, Inc.
;released to the public domain; however, it cannot be included in
; in any commercial software without prior written permission of the author.
;         

;please address questions, comments, suggestions to: 
; Skip Rowland/r3 Software Publishing & Consulting, Inc.
; (804) 739 - 7474
; CID 75260,2107

PROC zip.to.table.u (zip.file.a)
  PRIVATE
    h,
    color.s,
    m,
    month.a,
    day.a,
    year.a,
    spot.a,
    front.a,
    back.a,
    zip.line.a
    
    
  color.s = 30
  
;first, put all the zip info into a text file
  ECHO OFF
  h = win.message.h ("Extracting Zip Info from " + zip.file.a + "...",color.s)
  RUN NOREFRESH "pkzip -v " + zip.file.a + " >ziphas.txt"

;next, remove everything but the file specific information.  if it's not
; clear what is going on here, step through the code with the debugger or
; do a SHOWPLAY or set ECHO NORMAL 

  h = win.message.h ("Clearing Header Garbage...",color.s)
  MiniEdit {Open} {ziphas.txt} 
  Zoom {Name} 
  Down 
  ShiftPress "CtrlPgUp" 
  Del 
  Del 
  CtrlPgDn 
  ShiftPress "Up" 
  ShiftPress "Up" 
  Del Do_It! 
  
  h = win.message.h ("Importing...",color.s)
  MENU {Tools} {ExportImport} {Import} {ASCII} {Text} {ziphas.txt} {ziphas} 
  IF MENUCHOICE () = "Cancel" THEN {Replace} ENDIF

;next, add fields to match the columns of data.  [Position] is used so that
; the table can be viewed in the same order as the file order in the zip file.
  
  h = win.message.h ("Restructuring...",color.s)
  MENU {Modify} {Restructure} {ziphas} 
  DOWN 
  "Length"        TAB  "N"    DOWN  
  "Method"        TAB  "A7"   DOWN  
  "Size"          TAB  "N"    DOWN
  "Ratio"         TAB  "A4"   DOWN  
  "Date"          TAB  "D"    DOWN  
  "Time"          TAB  "A5"   DOWN 
  "CRC-32"        TAB  "A8"   DOWN  
  "Attr"          TAB  "A4"   DOWN  
  "Name"          TAB  "A12"  DOWN
  "Position"      TAB  "S"    
  
  DO_IT!   
  
  h = win.message.h ("Reformatting Data...",color.s)

;for some reason, pkzip skews the column format when the ratio = 100%. so,
; we have to go in and clean up the columns before we can break out the
; data...  
  COEDITKEY
  SCAN FOR SEARCH ("100%", [Text]) <> 0
    SOUND 50 50
    spot.s = SEARCH ("100%", [Text])
    front.a = SUBSTR ([Text],1,spot.s-2)
    back.a = SUBSTR ([Text],spot.s,LEN ([Text])-spot.s)
    [Text] = front.a + back.a
  ENDSCAN
  
;now, we split the text into its appropriate fields   
  SCAN
    [Position]     = RECNO ()
    
    zip.line.a = [Text]
    [Length]       = NUMVAL (SUBSTR (zip.line.a,1,7))
    [Method]       = SUBSTR (zip.line.a,10,7)
    [Size]         = NUMVAL (SUBSTR (zip.line.a,19,6))
    [Ratio]        = SUBSTR (zip.line.a,26,4)
    
    m = MATCH (SUBSTR (zip.line.a,31,8), "..-..-..", month.a, day.a, year.a)
    [Date]         = DATEVAL (month.a + "/" + day.a + "/" + year.a)
    
    [Time]         = SUBSTR (zip.line.a,41,5)
    [CRC-32]       = SUBSTR (zip.line.a,48,8)
    [Attr]         = SUBSTR (zip.line.a,57,4)
    [Name]         = SUBSTR (zip.line.a,63,12)
  ENDSCAN
  DO_IT!

;now, take out the [Text] field.  also, just for grins, we'll key 
; the table so that we can view it in different sort orders without 
; having to go through Modify|Sort each time.  

  h = win.message.h ("Reformatting Table...",color.s)
  MENU {Modify} {Restructure} {ziphas} 
  DEL 
  INS
  RIGHT
  "Name"
  RIGHT
  " "
  Do_It! 
  {Delete} 

;last, let's put in a date stamp index  
  h = win.message.h ("Indexing on Date & Time...",color.s)
  MENU {Modify} {Index} {ziphas}  "date stamp" 
  Down Down Down Down Down Down Down Down  "1" 
  Down  "2" 
  Do_It! 
  
  MOVETO [Date]
  ORDERTABLE DOWN ENTER
  
  END
  CTRLHOME
  
  winclose.u (h)
  
ENDPROC


PROC promptdialog.a (header.a,        ;for the dialog box
                     row.s,           
                     col.s,
                     varwidth.s,      ;how wide do you want the type-in to be?
                     datatype.a,
                     picture.a,       ;default is all caps: *!
                     var.a,           ;you can pass a default value
                     label.a,         ;the type-in label
                     buttonface.a)

  PRIVATE                     
    acceptcol.s,
    labelcol.s,
    width.s,
    opendialog.a,
    dialog.h,
    pulldown.a,
    width.s,
    absolute.s,
    labelcol.s,
    acceptcol.s,
    buttonwidth.s,
    splitspot.s,
    button1col,
    button2col,
    button.a,
    height.s,
    long.s,
    split.l,
    pulldown.a
    
  escape.menu.u ()  

;if i explained exactly what i was doing right here, i'd be doing a 
; disservice.  this took a fair amount of playing around, but it taught me
; a lot about dynamically scoping the ui.

;essentially, i evaluate the header, the label, and the var width to see
; how wide and how tall to make the dialog.  then i figure how big the
; buttons are and where they go.
    
  width.s = IIF (LEN (header.a) + 20 > 68, 68, LEN (header.a) + 20)
  absolute.s = LEN (label.a) + 2 + varwidth.s + 10
  IF absolute.s <= 68 THEN
    width.s = IIF (width.s > absolute.s, width.s, absolute.s)
  ELSE  
    long.s = IIF (LEN (label.a) >= varwidth.s, LEN (label.a), varwidth.s)
    IF LEN (label.a) + varwidth.s <= 68 THEN
      absolute.s = long.s + 12 
      split.l = TRUE
    ENDIF
  ENDIF
  IF absolute.s > 68 THEN
    width.s = IIF (width.s <= 68, width.s, 68)
  ELSE
    width.s = IIF (absolute.s <= 68, absolute.s, 68)
  ENDIF
    
  height.s = IIF (absolute.s > 68, 9, 8)
  IF absolute.s > 68 OR ISASSIGNED (split.l) THEN
    labelcol.s = 4
    acceptcol.s = 5
    acceptrow.s = 2
  ELSE
    labelcol.s = 4
    acceptcol.s = LEN (label.a) + 6
    acceptrow.s = 1
  ENDIF

  buttonwidth.s = IIF (LEN (buttonface.a) + 4 > 10, LEN (buttonface.a) + 4, 10)
  splitspot.s = INT (width.s/2)

  button1col.s = INT (splitspot.s/2) - INT (buttonwidth.s/2)
  button2col.s = (3 * INT (splitspot.s/2)) - INT (buttonwidth.s/2) - 2

  IF ISBLANK (picture.a) THEN
    picture.a = "*!"
  ENDIF
  
  ; PaintPAL_Generated_Code_Begin(449542984)

  SHOWDIALOG header.a
    @row.s,col.s HEIGHT height.s WIDTH width.s

    ; PaintPAL_Frame_Begin
    FRAME SINGLE FROM 0,1 TO height.s - 5,width.s - 4
    PAINTCANVAS ATTRIBUTE 127 0,1,0,width.s - 4
    PAINTCANVAS ATTRIBUTE 112 height.s - 5,1,height.s - 5,width.s - 4
    PAINTCANVAS ATTRIBUTE 127 0,1,height.s - 5,1
    PAINTCANVAS ATTRIBUTE 112 0,width.s - 4,height.s - 5,width.s - 4
    ; PaintPAL_Frame_End

    ACCEPT @acceptrow.s,acceptcol.s WIDTH varwidth.s
      datatype.a
      PICTURE picture.a
      TAG "alpha"
      TO var.a

    LABEL @1,labelcol.s
      label.a
      FOR "alpha"

    PUSHBUTTON @height.s - 4,button1col.s WIDTH buttonwidth.s
      buttonface.a
      OK
      DEFAULT
      TO button.a

    PUSHBUTTON @height.s - 4,button2col.s WIDTH buttonwidth.s
      "~C~ancel"
      CANCEL
      TO button.a
  ENDDIALOG

  ; PaintPAL_Generated_Code_End(449542984)
  
  IF NOT RETVAL THEN
    var.a = "Cancel"
  ENDIF
  
  IF ISBLANK (var.a) THEN
    var.a = "<blank>"
  ENDIF
  
  RETURN var.a
  
ENDPROC
  
  
PROC escape.menu.u ()

;>r3 change 3/6/95:  added this proc for 'escape only' menuing

  SHOWPULLDOWN ENDMENU
  PROMPT SPACES (80)  
  SPEEDBAR "~Esc~ Cancel":"Esc"
  ECHO NORMAL
  
ENDPROC  
  
  
PROC win.message.h (message.a, color.s)
  PRIVATE
    form.h,
    editor.h,
    cur.table.a,
    wa,
    base.s,
    up.s,
    down.s,
    text.s

;the purpose of win.message.h is to write a message on the screen, then
; return focus to the last current window (if any).  it returns it's
; handle.
;
; i usually assign the return to a variable named 'h'; i test inside this
; proc to see if h is assigned, if it is a window, and if so, if it has
; the same attributes as the window i normally create for messaging.  if so,
; if don't create a new window, but simply write over the old
;
; the message string can be up to 46 chars in length.  if it has '...'
; in the string, then the '...' will blink.

  base.s = INT (color.s/16) + 1
  up.s = (base.s * 16) - 16 + base.s - 1 + 8
  down.s = (base.s * 16) - 16
  text.s  = down.s + 10
  
  IF NIMAGES () > 0 AND IMAGETYPE () = "Display" THEN
    cur.table.a = TABLE ()
    IF SEARCH (SYSMODE (), "MAIN COEDIT") <> 0 THEN
      IF ISFORMVIEW () THEN
        WINDOW HANDLE FORM TO form.h
      ENDIF
    ELSE
      IF SEARCH (SYSMODE (), "SCRIPT FILE EDITOR") <> 0 THEN
        WINDOW HANDLE EDITOR TO editor.h
      ENDIF
    ENDIF
  ENDIF
  
  IF ISASSIGNED (h) AND ISWINDOW (h) THEN
    WINDOW SELECT h
    WINDOW GETATTRIBUTES h TO wa 
    SETCANVAS h
  ENDIF
    
  IF ISASSIGNED (wa) AND TYPE (wa) = "DY" AND 
     wa ["HASFRAME"] = FALSE AND
     wa ["HEIGHT"] = 5 AND
     wa ["WIDTH"] = 55 AND
     wa ["ORIGINROW"] = 17 AND
     wa ["ORIGINCOL"] = 12 THEN
  ELSE       
  
    DYNARRAY wa []
    wa ["ORIGINROW"] = 17
    wa ["ORIGINCOL"] = 12
    wa ["HEIGHT"] = 5
    wa ["WIDTH"] = 55
    wa ["HASFRAME"] = FALSE
    wa ["FLOATING"] = TRUE  
    ECHO OFF
    WINDOW CREATE ATTRIBUTES wa TO h
    PAINTCANVAS ATTRIBUTE 31 0,0,5,55
  
    FRAME SINGLE FROM 0,0 TO 4,54
    PAINTCANVAS ATTRIBUTE up.s   0,0,4,54
    PAINTCANVAS ATTRIBUTE down.s 4,1,4,54  
    PAINTCANVAS ATTRIBUTE down.s 0,54,4,54
  
  ENDIF
  
  STYLE ATTRIBUTE text.s
  @2,4 ?? FORMAT ("W46,AL", message.a)
      
  blink.s = SEARCH ("...", message.a)
  IF blink.s <> 0 THEN
    PAINTCANVAS ATTRIBUTE text.s + 128 2,3+blink.s,2,5+blink.s
  ENDIF
  
  IF ISASSIGNED (form.h) THEN
    WINDOW SELECT form.h
  ENDIF
  
  IF ISASSIGNED (cur.table.a) THEN  
    MOVETO cur.table.a
  ENDIF

  IF ISASSIGNED (editor.h) THEN
    WINDOW SELECT editor.h
  ENDIF
  
  ECHO NORMAL ECHO OFF
  
  RETURN h
  
ENDPROC 
  
  
PROC winclose.u (windowhandle.h)
     
  IF NOT ISWINDOW (windowhandle.h) THEN
    RETURN
  ENDIF   
  WINDOW SELECT windowhandle.h
  WINDOW CLOSE
  ECHO NORMAL ECHO OFF
  
ENDPROC  

  zip.file.a = ""
  WHILE TRUE
    zip.file.a = promptdialog.a ("r3 Zip-2-File", ;header.a
                                 5,               ;row.s
                                 5,               ;col.s
                                 11,              ;varwidth.s
                                 "A8",            ;datatype.a
                                 "*!",            ;picture.a
                                 zip.file.a,      ;var.a
                                 "~Z~ip File:",   ;label.a
                                 " ~O~k ")        ;buttonface.a
    IF zip.file.a = "Cancel" THEN
      RETURN
    ENDIF
    IF zip.file.a = "<blank>" THEN
      MESSAGE "Filename required"
      zip.file.a = ""
      LOOP
    ENDIF               
    IF NOT ISFILE (zip.file.a + ".zip") THEN
      MESSAGE zip.file.a + " not found."
      LOOP
    ENDIF    
    QUITLOOP
  ENDWHILE 
  
  zip.to.table.u (zip.file.a)  